#include <algorithm> // 'std::for_each'
#include <iostream>
#include <string>

#include "Palindrome.h"
#include "Utilities.h"

int main(int argc, char** argv) {
    Substituable_character a('a',{''}); // Aggregate initialization
    Substituable_character e('e',{'', '', ''}); // Aggregate initialization
    std::cout << "e.toString(): " << e.toString() << std::endl;
    Substituable_character u('u',{''}); // Aggregate initialization
    // Etc.
    std::cout << a.operator()('') << std::endl; // 'a'

    // '' as 'char' creates a (non-surprising) conflict between "Cumulative" and "Cumulatives"
    std::cout << "::Cumulate(std::string(1, e.character),\"\",\"\",\"\"): "
            // C++17 allows the inference of types between '<>':
            << ::Cumulate/*<std::string,std::string>*/(std::string(1, e.character), "", "", "") << std::endl;

    /* Test of transform 'std::array' into pack... */
    std::array<std::string, 4U> my_array{
        {"e", "", "", ""}};
    // Instantiation: T=std::string; N=4U; Indices=__make_integer_seq_alias<std::integer_sequence, unsigned int, 4U>
    std::cout << "std__array_to_pack(my_array): " << ::std__array_to_pack(my_array) << std::endl; // This calls '::Cumulate'

    std::cout << "Cumulate_to_illustrate_lambda_expression(std::string(1, e.character),\"\",\"\",\"\"): "
		<< ::Cumulate_to_illustrate_lambda_expression(std::string(1, e.character), "", "", "") << std::endl;

    Palindrome_word pw("lu");
    pw.alter(e);
    std::cout << pw.toString() << std::endl; // 'elu'

    Palindrome_word pw_("ici et l");
    pw_.alter(a);
    std::cout << pw_.toString() << std::endl; // "ici et la"

    Palindrome p1{ "par", "lu", "cette", "crapule"}; // Aggregate initialization
    std::cout << p1.toString() << ": " << std::boolalpha << p1.isPalindrome() << std::endl; // 'true'

    return 0;
}

